#    Society Self-Service
#    Copyright © 2018-2019  Yingtong Li (RunasSudo)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <https://www.gnu.org/licenses/>.

from django.contrib.auth import logout as auth_logout
from django.contrib.auth.decorators import login_required

from django.conf import settings
from django.http import HttpResponse
from django.shortcuts import render, redirect
from django.urls import reverse

import urllib.parse

def index(request):
	if request.user.is_authenticated:
		return redirect(reverse('splash'))
	return render(request, 'ssmain/index.html')

def login(request):
	baseurl = reverse('social:begin', args=['google-oauth2'])
	if 'next' in request.GET:
		baseurl += '?' + urllib.parse.urlencode({'next': request.GET['next']})
	return redirect(baseurl)

def logout(request):
	auth_logout(request)
	return redirect(reverse('index'))

@login_required
def splash(request):
	return render(request, 'ssmain/splash.html', {'apps': settings.INSTALLED_APPS})
